<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Quản lý bảng điểm</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Select 2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Tempusdominus Bootstrap 4 -->
    <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item">
            <a href="#" class="nav-link">
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <p>Quản lý bảng điểm</p>
                </a>
              </li>
            </ul>
          </li>          
        </ul>
      </nav><!-- /.sidebar-menu -->
    </div><!-- /.sidebar -->
  </aside> <!-- /aside -->

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-3">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Trang chủ</a></li>
              <li class="breadcrumb-item active">Quản lý bảng điểm</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section><!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản lý bảng điểm</h2>
        <div class="row mt-2">
          <div class="col-sm-4">
                <label>Student</label>
                <select id="select-filter-student" class="form-control select-2 select-student" >
                  <option value="0">Tất cả students</option>
                </select>
          </div>
          <div class="col-sm-4">
              <label>Subject</label>
              <select id="select-filter-subject" class="form-control select-2 select-subject">
                <option value="0">Tất cả subjects</option>
              </select>
          </div>
          <div class="col-sm-3 d-flex">
            <button id="btn-filter" class="btn btn-success align-self-end"><i class='fas fa-filter'></i> Filter</button>
          </div>
        </div>
        <div class="row mt-3 mb-3">
          <div class="col-sm-4">
            <button type="button" id="btn-create-entry" class="btn btn-success"><i class="fas fa-plus"></i> Thêm mới</button>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="grades-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Sinh viên</th>
              <th width="30%">Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
              <th>Actions</th>
            </tr>
          </thead>
          <tbody>
          </tbody>
        </table>
      </div><!-- /.container -->
      
    <!-- Modal entry create-->
    <div class="modal fade" id="modal-entry-create" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Entry create</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div><!-- /.modal-header -->
          <div class="modal-body">

            <form id="create-form">
              <div class="row form-group">
                <div class="col-sm-3">
                    <label>Student</label>
                </div>
                <div class="col">
                  <select id="create-studentId" class="form-control select-2 select-student"></select>
                </div>
              </div>
              <div class="row form-group">
              <div class="col-sm-3">
                  <label>Subject</label>
              </div>
              <div class="col">
                <select id="create-subjectId" class="form-control select-2 select-subject"></select>
              </div>
          </div><div class="row form-group">
              <div class="col-sm-3">
                  <label>Grade</label>
              </div>
              <div class="col">
                  <input type="number" class="form-control" id="create-grade" min="0" max="10" step="0.1">
              </div>
          </div><div class="row form-group">
              <div class="col-sm-3">
                  <label>Exam Date</label>
              </div>
              <!-- Date -->
              <div class="col">
                <div class="input-group date" id="create-entry-date" data-target-input="nearest">
                  <input id="create-examDate" type="text" class="form-control datetimepicker-input" data-target="#create-entry-date"/>
                  <div class="input-group-append" data-target="#create-entry-date" data-toggle="datetimepicker">
                      <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                  </div>
                </div>
              </div>
          </div></form>
          </div><!-- /.modal-body -->
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-success" id="btn-create-entry-confirm">Create</button>
          </div><!-- /.modal-footer -->
        </div><!-- /.modal-content-->
      </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->

    <!-- Modal entry detail-->
    <div class="modal fade" id="modal-entry-detail" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Entry detail</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div><!-- /.modal-header -->
          <div class="modal-body">

            <form id="detail-form">
              <div class="row form-group">
                <div class="col-sm-3">
                    <label>ID</label>
                </div>
                <div class="col-sm-2">
                  <input id="detail-id" class="form-control" readonly>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                    <label>Student</label>
                </div>
                <div class="col">
                  <select id="detail-studentId" class="form-control select-2 select-student"></select>
                </div>
              </div>
              <div class="row form-group">
              <div class="col-sm-3">
                  <label>Subject</label>
              </div>
              <div class="col">
                <select id="detail-subjectId" class="form-control select-2 select-subject"></select>
              </div>
          </div><div class="row form-group">
              <div class="col-sm-3">
                  <label>Grade</label>
              </div>
              <div class="col">
                  <input type="number" class="form-control" id="detail-grade" min="0" max="10" step="0.1">
              </div>
          </div><div class="row form-group">
              <div class="col-sm-3">
                  <label>Exam Date</label>
              </div>
              <!-- Date -->
              <div class="col">
                <div class="input-group date" id="detail-exam-date" data-target-input="nearest">
                  <input id="detail-examDate" type="text" class="form-control datetimepicker-input" data-target="#detail-exam-date"/>
                  <div class="input-group-append" data-target="#detail-exam-date" data-toggle="datetimepicker">
                      <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                  </div>
                </div>
              </div>
          </div></form>
          </div><!-- /.modal-body -->
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-success" id="btn-detail-entry-update">Update</button>
          </div><!-- /.modal-footer -->
        </div><!-- /.modal-content-->
      </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->

    <!-- Modal entry delete-->
    <div class="modal fade" id="modal-entry-delete" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Entry delete confirmation</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div><!-- /.modal-header -->
          <div class="modal-body">
            <div class="row">
              <div class="col">
                <p>Are you sure you want to delete this entry?</p>
              </div>
            </div>
            <div class="row">
              <div class="col-sm-2">
                <label>ID</label>
                <input id="delete-id" class="form-control" readonly>
              </div>
            </div>
            
          </div><!-- /.modal-body -->
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-danger" id="btn-detail-delete-confirm">Confirm</button>
          </div><!-- /.modal-footer -->
        </div><!-- /.modal-content-->
      </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->

    </section><!-- /.content -->
  </div><!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer><!-- /.main-footer -->

</div><!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables -->
<script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.12.1/js/dataTables.bootstrap4.min.js"></script>
<!-- InputMask -->
<script src="plugins/moment/moment.min.js"></script>
<script src="plugins/inputmask/jquery.inputmask.min.js"></script>
<!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- Page specific script -->
​<script>

  
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
var gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
var gSTT = 1;
var gStudents = [];
var gSubjects = [];
var gGrades = [];
var gGradesTable = $("#grades-table").DataTable({
  columns: [
    {data: "STT", render: function() {
      return gSTT++ ;
    }},
    {data: "studentId", render: function(studentId) {
        return getStudentNameFromId(studentId) ;
    }},
    {data: "subjectId", render: function(subjectId) {
      return getSubjectNameFromId(subjectId) ;
    }},
    {data: "grade"},
    {data: "examDate"},
    {data: "action",
      defaultContent: `
      <i type="button" class="fas fa-edit entry-detail"></i>
      <i type="button" class="fas fa-trash entry-delete"></i>
      `},
  ]
})
/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
$(function() {
  onPageLoading();
  $(".select-2").select2({
    theme: 'bootstrap4'
  });
  $("#btn-filter").click( onBtnFilterClick );
  $("#btn-create-entry").click( onBtnCreateEntryClick );
  $("#btn-create-entry-confirm").click( ajaxCreateGrade );
  $("#grades-table").on("click", ".entry-detail" ,function() {
    onBtnDetailClick($(this));
  });
  $("#btn-detail-entry-update").click( ajaxUpdateGrade );
  $("#btn-detail-delete-confirm").click( ajaxDeleteGrade );
  $("#grades-table").on("click", ".entry-delete" ,function() {
    onBtnDeleteClick($(this));
  });
  //Date picker
  $('#detail-exam-date').datetimepicker({
    format: 'DD/MM/YYYY'
  });
  $('#create-entry-date').datetimepicker({
    format: 'DD/MM/YYYY'
  });

})
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading() {
  loadAllGradesToTable();
  getAllStudents();
  getAllSubjects();
  loadStudentsToStudentSelect();
  loadSubjectsToSubjectSelect();
}

function onBtnCreateEntryClick() {
  $("#modal-entry-create").modal("show");
}
function onBtnDeleteClick(paramButton) {
  var vRowData = getRowDataFromButton(paramButton);
  $("#modal-entry-delete").modal("show");
  $("#delete-id").val(vRowData.id);
}

// hàm xử lý sự kiện ấn nút chi tiết
function onBtnDetailClick(paramButton) {
  var vRowData = getRowDataFromButton(paramButton);   
  $("#modal-entry-detail").modal("show");

  for (const [key, value] of Object.entries(vRowData)) {
    $("#detail-" + key).val(value);
  }
}
function ajaxCreateGrade() {
  var vGradeObjRequest = {
    studentId: $("#create-studentId").val(),
    subjectId: $("#create-subjectId").val(),
    grade: $("#create-grade").val(),
    examDate: $("#create-examDate").val()
  };
  $.ajax({
    url: gBASE_URL + "/grades",
    data: JSON.stringify(vGradeObjRequest),
    type: "POST",
    contentType: "application/json",
    success: function(response) {
      $(document).Toasts('create', {
        class: 'bg-success',
        title: 'Tạo entry mới thành công',
        autohide: true,
        delay: 1500
      })
      $("#modal-entry-create").modal("hide");
      loadAllGradesToTable();
    }
  })
}

function ajaxUpdateGrade() {
  var vGradeId = $("#detail-id").val();
  var vGradeObjRequest = {
    studentId: $("#detail-studentId").val(),
    subjectId: $("#detail-subjectId").val(),
    grade: $("#detail-grade").val(),
    examDate: $("#detail-examDate").val()
  };
  $.ajax({
    url: gBASE_URL + "/grades/" + vGradeId,
    data: JSON.stringify(vGradeObjRequest),
    type: "PUT",
    contentType: "application/json",
    success: function(response) {
      $(document).Toasts('create', {
        class: 'bg-success',
        title: 'Sửa entry thành công',
        autohide: true,
        delay: 1500
      })
      $("#modal-entry-detail").modal("hide");
      loadAllGradesToTable();
    }
  })
}
function ajaxDeleteGrade() {
  var vGradeId = $("#delete-id").val();
  $.ajax({
    url: gBASE_URL + "/grades/" + vGradeId,
    type: "DELETE",
    contentType: "application/json",
    success: function(response) {
      $(document).Toasts('create', {
        class: 'bg-warning',
        title: 'Xoá entry thành công',
        autohide: true,
        delay: 1500
      })
      $("#modal-entry-delete").modal("hide");
      loadAllGradesToTable();
    }
  })
}

// hàm xử lý sự kiện ấn nút chi tiết
function onBtnDetailClick(paramButton) {
  var vRowData = getRowDataFromButton(paramButton);   
  $("#modal-entry-detail").modal("show");

  for (const [key, value] of Object.entries(vRowData)) {
    $("#detail-" + key).val(value);
  }
}
/*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
// hàm lấy dữ liệu của row của nút được ấn
function getRowDataFromButton(paramButton) {
    var vThisRow = paramButton.closest("tr");
    var vRowData = gGradesTable.row(vThisRow).data();
    return vRowData;
}
function loadAllGradesToTable() {
    $.ajax({
      url: gBASE_URL + "/grades",
      type: "GET",
      success: function(allGrades) {
        gGrades = allGrades;
        loadGradesToGradesTable(allGrades);
      }
    }) 
  }
function loadGradesToGradesTable(paramGrades) {
  gGradesTable.clear();
  gSTT = 1;
  gGradesTable.rows.add(paramGrades);
  gGradesTable.draw(false);
}
function getStudentNameFromId(paramId) {
  let vFoundStudent = gStudents.find(student => student.id == paramId);
  if (vFoundStudent != undefined) {
    return vFoundStudent.firstname + " " + vFoundStudent.lastname;
  }
  return ""
}

function getSubjectNameFromId(paramId) {
  let vFoundSubject = gSubjects.find(subject => subject.id == paramId);
  if (vFoundSubject != undefined) {
    return vFoundSubject.subjectName
  }
  return ""
}

function getAllStudents() {
  $.ajax({
    url: gBASE_URL + "/students",
    type: "GET",
    async: false,
    success: function(allStudents) {
      gStudents = allStudents;
    }
  }) 
}
function getAllSubjects() {
  $.ajax({
    url: gBASE_URL + "/subjects",
    type: "GET",
    async: false,
    success: function(allSubjects) {
      gSubjects = allSubjects;
    }
  }) 
}

function loadStudentsToStudentSelect() {
  gStudents.forEach(student => {
      $("<option>",{ 
        val: student.id,
        text: student.firstname + " " + student.lastname,
        })
        .appendTo ($(".select-student"))
  });
}
function loadSubjectsToSubjectSelect() {
  gSubjects.forEach(subject => {
      $("<option>",{ 
        val: subject.id,
        text: subject.subjectName
        })
        .appendTo ($(".select-subject"))
  });
}
function onBtnFilterClick() {
  var vFilteredGrades = gGrades;
  vFilteredGrades = filterByStudent(vFilteredGrades);
  vFilteredGrades = filterBySubject(vFilteredGrades);
  loadGradesToGradesTable(vFilteredGrades)
}
function filterByStudent(paramGrades) {
  var vFilterStudentId = $("#select-filter-student").val()
  if (vFilterStudentId != "0"){
    return paramGrades.filter(grade => grade.studentId == vFilterStudentId)
  } else {
    return paramGrades
  }
}

function filterBySubject(paramGrades) {
  var vFilterSubjectId = $("#select-filter-subject").val()
  if (vFilterSubjectId != "0"){
    return paramGrades.filter(grade => grade.subjectId == vFilterSubjectId)
  } else {
    return paramGrades
  }
}
</script>
</body>
</html>
